<template>
  <div class="applicationProfile">
    <!-- Application Profile Dropdown -->
    <CoscineFormGroup
      label-for="applicationProfiles"
      :mandatory="true"
      :label="
        $t('page.createResource.applicationProfile.applicationProfileLabel')
      "
      :is-loading="isLoading"
      info
    >
      <!-- Info Popover -->
      <template #popover>
        {{
          $t("page.createResource.applicationProfile.applicationProfilePopover")
        }}
        <b-link
          :href="
            $t(
              'page.createResource.applicationProfile.applicationProfilePopoverUrl',
            ).toString()
          "
          target="_blank"
        >
          {{ $t("default.help") }}
        </b-link>
      </template>

      <!-- Dropdown -->
      <div class="d-inline-flex align-items-center gap-2 w-100">
        <multiselect
          id="applicationProfiles"
          v-model="selectedApplicationProfile"
          :options="groupedApplicationProfiles"
          :multiple="false"
          :hide-selected="false"
          label="displayName"
          track-by="uri"
          group-values="profiles"
          group-label="uri"
          :group-select="false"
          :show-labels="false"
          :placeholder="
            $t(
              'page.createResource.applicationProfile.selectApplicationProfile',
            )
          "
          select-label=""
          selected-label=""
          deselect-label=""
          :class="{
            invalid: v$.resourceForCreation.applicationProfile.$dirty
              ? v$.resourceForCreation.applicationProfile.$invalid
              : false,
          }"
          @update:modelValue="setSelectedApplicationProfile"
          @search-change="applicationProfileSearchChange"
        >
          <template #afterList>
            <div
              v-if="groupedApplicationProfiles.length && !allResultsLoaded"
              v-observe-visibility="reachedEndOfAPList"
            >
              <div class="d-flex justify-content-left my-3 ps-3">
                <b-spinner v-if="isLoadingResults" small />
              </div>
            </div>
          </template>
          <template #noResult>
            {{ $t("page.createResource.multiselect.noResults") }}
          </template>
          <template #noOptions>
            {{ $t("page.createResource.multiselect.noOptions") }}
          </template>
        </multiselect>

        <!-- Create Button -->
        <span id="createButton">
          <b-button
            variant="outline-primary"
            name="createAP"
            class="d-flex gap-2 justify-content-between align-items-center w-fit"
            @click="createAPModal.show()"
          >
            <i-bi-file-earmark-plus aria-hidden="true" />
            {{ $t("buttons.create") }}
          </b-button>
        </span>

        <b-tooltip target="createButton" triggers="hover">
          <i18n-t
            scope="global"
            keypath="page.createResource.applicationProfile.createAp.tooltip"
          />
        </b-tooltip>
      </div>

      <!-- Hint -->
      <template #hint>
        {{
          $t("page.createResource.applicationProfile.applicationProfileHint")
        }}
      </template>
    </CoscineFormGroup>

    <!-- Create Application Profile Modal -->
    <CreateAPModal id="createAPModal" />

    <!-- Form Generator -->
    <b-row v-if="isLoadingFormGenerator" align-h="center" class="my-2">
      <b-spinner variant="primary" />
    </b-row>
    <FormGenerator
      :key="resourceForCreation.applicationProfile?.uri"
      :fixed-value-mode="fixedValueMode"
      :fixed-values="fixedValues"
      :locale="$i18n.locale"
      :selected-shape="resourceForCreation.applicationProfile?.uri"
      :shapes="applicationProfile"
      :class-receiver="getVocabularyInstances"
      :instance-receiver="getVocabularyInstance"
      :user-receiver="async () => user"
      shape-mime-type="application/ld+json"
      @update:fixed-values="inputFixedValues"
    />
  </div>
</template>

<script lang="ts" setup>
// import the store for current module
import useResourceStore from "../../store";
import useUserStore from "@/modules/user/store";
import type { Dataset } from "@rdfjs/types";
import type {
  BilingualLabel,
  BilingualLabels,
  FixedValuesForResource,
  GroupedApplicationProfile,
} from "../../types";
import type {
  ApplicationProfileDto,
  ApplicationProfileForResourceCreationDto,
  ResourceForCreationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import useVuelidate from "@vuelidate/core";
import { required, url } from "@vuelidate/validators";
import CreateAPModal from "./modals/CreateAPModal.vue";
import { useDebounceFn } from "@vueuse/core";
import { useModal } from "bootstrap-vue-next";
import type { FixedValues } from "@coscine/form-generator/dist/types/fixedValues";

const resourceForCreation = defineModel<ResourceForCreationDto>({
  required: true,
});

const props = defineProps({
  allResultsLoaded: {
    default: false,
    type: Boolean,
  },
  applicationProfile: {
    type: [Object, null] as PropType<Dataset | null>,
    default: null,
  },
  applicationProfiles: {
    type: Array as PropType<ApplicationProfileDto[]>,
    required: true,
  },
  isLoadingResults: {
    default: false,
    type: Boolean,
  },
  isLoadingFormGenerator: {
    type: Boolean,
    required: true,
  },
  isLoading: {
    default: false,
    type: Boolean,
  },
});

const emit = defineEmits<{
  applicationProfileSearchChange: [_: string];
  reachedEndOfAPList: [];
  valid: [_: boolean];
}>();

const resourceStore = useResourceStore();
const userStore = useUserStore();
/*
      Definition of the validation rules and initial state
      will enable proper typings in the code
    */
const state = reactive({
  resourceForCreation: resourceForCreation,
});
const rules = {
  resourceForCreation: {
    applicationProfile: {
      uri: [required, url],
    },
  },
};
const v$ = useVuelidate(rules, state);
const applicationProfileSearchChange = useDebounceFn((searchTerm: string) => {
  emit("applicationProfileSearchChange", searchTerm);
}, 500);

const createAPModal = useModal("createAPModal");

const fixedValueMode = ref(true);
const selectedApplicationProfile = ref(
  {} as
    | ApplicationProfileDto
    | ApplicationProfileForResourceCreationDto
    | undefined,
);

const user = computed(() => {
  return userStore.user ?? { displayName: undefined };
});
const groupedApplicationProfiles = computed(() => {
  return groupApplicationProfiles(props.applicationProfiles);
});
const fixedValues = computed(() => {
  return resourceForCreation.value.fixedValues as FixedValues;
});

watch(
  () => v$.value.resourceForCreation.$invalid,
  () => {
    emit("valid", !v$.value.resourceForCreation.$invalid);
  },
);

/**
 * Initializes the content of the selected application profile based on the current state of the resource for creation.
 */
const initTabContent = () => {
  // An application profile has been selected. Set selection in dropdown.
  if (resourceForCreation.value.applicationProfile) {
    selectedApplicationProfile.value = props.applicationProfiles.find(
      (ap) => ap.uri === resourceForCreation.value.applicationProfile.uri,
    );
  }
};

/**
 * Sets the fixed values for a resource's creation.
 *
 * @param {Record<string, unknown>} fixedValues - The fixed values to be set.
 * @returns {void}
 */
const inputFixedValues = (fixedValues: Record<string, unknown>): void => {
  resourceForCreation.value.fixedValues = fixedValues as FixedValuesForResource; // TODO: Fix type
};

/**
 * Fetches vocabulary instance from the store.
 */
const getVocabularyInstance = async (
  instanceUrl: string,
): Promise<BilingualLabel> => {
  return await resourceStore.getVocabularyInstance(instanceUrl);
};

/**
 * Retrieves the vocabulary instances for a given class name.
 *
 * @param {string} className - The name of the class to get vocabulary instances for.
 * @param {number} pageNumber - The pageNumber for retrieving the correct page of files.
 * @param {number} pageSize - The pageSize for retrieving the correct size of the files.
 * @returns {Promise<BilingualLabels>} A Promise that resolves with the BilingualLabels object representing the vocabulary instances.
 */
const getVocabularyInstances = async (
  className: string,
  pageNumber: number,
  pageSize: number,
  searchTerm?: string | undefined,
): Promise<BilingualLabels> => {
  return await resourceStore.getVocabularyInstances(
    className,
    pageNumber,
    pageSize,
    searchTerm,
  );
};

/**
 * Groups the given array of ApplicationProfileDto objects based on their base URLs.
 *
 * @param {ApplicationProfileDto[]} applicationProfiles - An array of ApplicationProfileDto objects to be grouped.
 * @returns {GroupedApplicationProfile[]} An array of GroupedApplicationProfile objects representing the grouped application profiles.
 */
const groupApplicationProfiles = (
  applicationProfiles: ApplicationProfileDto[],
): GroupedApplicationProfile[] => {
  const groupedProfiles: GroupedApplicationProfile[] = [];

  for (const applicationProfile of applicationProfiles) {
    // Extract AP hierarchy from URIs
    const uri = applicationProfile.uri || "";
    let text = uri.replace("https://purl.org/coscine/ap/", "");
    if (text.charAt(text.length - 1) === "/") {
      text = text.substring(0, text.lastIndexOf("/"));
    }
    // The Application Profile has a dedicated group
    const groupName = text.split("/")[0].toUpperCase();

    const groupEntry = groupedProfiles.find(
      (element) => element.uri === groupName,
    );

    if (groupEntry && groupEntry.profiles) {
      groupEntry.profiles.push(applicationProfile);
    } else {
      groupedProfiles.push({
        uri: groupName,
        profiles: [applicationProfile],
      });
    }
  }
  return groupedProfiles;
};

/**
 * Propagate that end of AP list has been hit.
 */
const reachedEndOfAPList = () => {
  if (!props.allResultsLoaded) {
    emit("reachedEndOfAPList");
  }
};

/**
 * Sets the selected application profile.
 */
const setSelectedApplicationProfile = () => {
  resourceForCreation.value.applicationProfile = {
    uri: selectedApplicationProfile.value?.uri,
  } as ApplicationProfileForResourceCreationDto;
  v$.value.resourceForCreation.applicationProfile.$touch();
};

initTabContent();
</script>
